#ifndef lint
/*static char yysccsid[] = "from: @(#)yaccpar	1.9 (Berkeley) 02/21/93";*/
static char yyrcsid[]
#if __GNUC__ == 2
  __attribute__ ((unused))
#endif /* __GNUC__ == 2 */
  = "$OpenBSD: skeleton.c,v 1.18 2001/11/19 19:02:18 mpech Exp $";
#endif
#include <stdlib.h>
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYLEX yylex()
#define YYEMPTY -1
#define yyclearin (yychar=(YYEMPTY))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING() (yyerrflag!=0)
#define YYPREFIX "yy"
#line 31 "parse.y"
#include <sys/types.h>

#include "config.h"

#ifdef HAVE_SYS_TIME_H
#include <sys/time.h>
#endif
#include <sys/tree.h>
#include <sys/queue.h>

#include <stdio.h>
#include <stdlib.h>
#include <err.h>
#include <stdarg.h>
#include <string.h>

#include <dnet.h>

#include <event.h>

#include "honeyd.h"
#include "personality.h"
#include "router.h"

int yylex(void);
int yyparse(void);

struct template;
int template_create(char *);
int template_add(struct template *, int, int, struct action *);
int template_clone(char *, struct template *);
struct template *template_find(char *);

struct action *honeyd_protocol(struct template *, int);

void port_action_clone(struct action *, struct action *);

int lineno;
char *filename;
int errors = 0;

#line 93 "parse.y"
typedef union {
	char *string;
	int number;
	struct addr addr;
	struct action action;
	struct template *tmpl;
	struct personality *pers;
	struct addrinfo *ai;
	enum fragpolicy fragp;
	float floatp;
} YYSTYPE;
#line 74 "y.tab.c"
#define CREATE 257
#define ADD 258
#define PORT 259
#define BIND 260
#define CLONE 261
#define DOT 262
#define BLOCK 263
#define OPEN 264
#define RESET 265
#define DEFAULT 266
#define SET 267
#define ACTION 268
#define PERSONALITY 269
#define RANDOM 270
#define ANNOTATE 271
#define NO 272
#define FINSCAN 273
#define FRAGMENT 274
#define DROP 275
#define OLD 276
#define NEW 277
#define COLON 278
#define PROXY 279
#define UPTIME 280
#define DROPRATE 281
#define IN 282
#define UID 283
#define GID 284
#define ROUTE 285
#define ENTRY 286
#define LINK 287
#define NET 288
#define SLASH 289
#define LATENCY 290
#define MS 291
#define LOSS 292
#define STRING 293
#define CMDSTRING 294
#define NUMBER 295
#define PROTO 296
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,    0,    0,    0,    0,    0,    0,   12,   12,   13,
   14,   14,   15,   15,   15,   15,   15,   15,   16,   16,
   17,   17,   17,    7,    7,    8,    8,    8,    1,    2,
    3,    4,    4,    4,    4,    4,    4,    4,    4,    5,
    5,    5,    6,    6,    9,    9,   10,   10,   11,   11,
};
short yylen[] = {                                         2,
    0,    2,    2,    2,    2,    2,    2,    2,    2,    6,
    3,    3,    6,    4,    4,    5,    4,    6,    3,    3,
    3,    8,    4,    1,    2,    2,    2,    2,    7,    3,
    3,    1,    1,    2,    4,    4,    1,    1,    1,    1,
    1,    1,    1,    1,    3,    1,    0,    3,    0,    2,
};
short yydefred[] = {                                      1,
    0,    0,    0,    0,    0,    0,    0,    0,    2,    3,
    4,    5,    6,    7,    9,    8,   41,   40,    0,   42,
    0,    0,    0,    0,   44,   43,    0,    0,    0,    0,
    0,   11,   12,    0,    0,    0,    0,    0,    0,   24,
    0,   19,   20,   21,    0,    0,    0,    0,    0,   14,
   15,    0,    0,   25,   26,   27,   28,    0,    0,   23,
    0,    0,    0,    0,   16,    0,    0,    0,    0,   37,
   39,   38,    0,   32,   33,   10,   13,    0,   18,    0,
   30,    0,    0,    0,   34,   45,    0,    0,   29,    0,
    0,    0,    0,   22,   36,   35,   31,   48,   50,
};
short yydgoto[] = {                                       1,
   20,   60,   85,   76,   21,   27,   42,   43,   65,   88,
   94,    9,   10,   11,   12,   13,   14,
};
short yysindex[] = {                                      0,
 -241, -259, -264, -287, -266, -264, -258, -249,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, -234,    0,
 -263, -264, -264, -231,    0,    0, -217, -287, -255, -247,
 -208,    0,    0, -243, -258, -237, -223, -235, -212,    0,
 -262,    0,    0,    0, -226, -287, -198, -230, -202,    0,
    0, -228, -216,    0,    0,    0,    0, -287, -219,    0,
 -224, -254, -254, -190,    0, -222, -287, -221, -187,    0,
    0,    0, -252,    0,    0,    0,    0, -218,    0, -214,
    0, -215, -200, -199,    0,    0, -213, -211,    0, -248,
 -210, -207, -228,    0,    0,    0,    0,    0,    0,
};
short yyrindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    6,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   18,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    1,
    0,    0,    0,    0,    0,    0,    0,   23,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,
};
short yygindex[] = {                                      0,
   -4,   25,    0,   24,   -1,   51,    0,    0,   -5,    0,
    0,    0,    0,    0,    0,    0,    0,
};
#define YYTABLESIZE 308
short yytable[] = {                                      22,
   47,   17,   45,   29,   24,   17,   15,   19,   70,   71,
   72,   25,   55,   56,   57,    2,    3,   46,    4,    5,
   32,   33,   49,   44,   73,    6,   23,   30,   18,    7,
   19,   46,   31,   16,   34,   26,   28,   35,   74,   75,
   83,   59,   19,    8,   95,   19,   96,   47,   36,   37,
   48,   38,   49,   59,   39,   40,   41,   51,   52,   53,
   54,   58,   80,   61,   62,   63,   64,   66,   84,   68,
   69,   78,   79,   81,   82,   87,   86,   90,   91,   89,
   93,   92,   67,   98,   97,   50,   77,   99,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   47,   47,    0,
   47,   47,   17,   17,    0,   17,   17,   47,    0,    0,
    0,   47,   17,    0,   46,   46,   17,   46,   46,   49,
   49,    0,   49,   49,   46,   47,    0,    0,   46,   49,
   17,    0,   47,   49,    0,    0,    0,    0,    0,    0,
    0,    0,   46,    0,    0,    0,    0,   49,
};
short yycheck[] = {                                       4,
    0,  266,  258,    8,    6,    0,  266,  295,  263,  264,
  265,  270,  275,  276,  277,  257,  258,    0,  260,  261,
   22,   23,    0,   28,  279,  267,  293,  262,  293,  271,
  295,  287,  296,  293,  266,  294,  286,  269,  293,  294,
  293,   46,  295,  285,  293,  295,  295,  295,  280,  281,
  259,  283,  296,   58,  272,  273,  274,  295,  282,  295,
  273,  288,   67,  262,  295,  268,  295,  284,   73,  289,
  295,  262,  295,  295,  262,  290,  295,  278,  278,  295,
  292,  295,   58,  291,  295,   35,   63,   93,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,   -1,
  260,  261,  257,  258,   -1,  260,  261,  267,   -1,   -1,
   -1,  271,  267,   -1,  257,  258,  271,  260,  261,  257,
  258,   -1,  260,  261,  267,  285,   -1,   -1,  271,  267,
  285,   -1,  292,  271,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  285,   -1,   -1,   -1,   -1,  285,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 296
#if YYDEBUG
#if defined(__cplusplus) || __STDC__
const char * const yyname[] =
#else
char *yyname[] =
#endif
	{
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"CREATE","ADD","PORT","BIND",
"CLONE","DOT","BLOCK","OPEN","RESET","DEFAULT","SET","ACTION","PERSONALITY",
"RANDOM","ANNOTATE","NO","FINSCAN","FRAGMENT","DROP","OLD","NEW","COLON",
"PROXY","UPTIME","DROPRATE","IN","UID","GID","ROUTE","ENTRY","LINK","NET",
"SLASH","LATENCY","MS","LOSS","STRING","CMDSTRING","NUMBER","PROTO",
};
#if defined(__cplusplus) || __STDC__
const char * const yyrule[] =
#else
char *yyrule[] =
#endif
	{"$accept : config",
"config :",
"config : config creation",
"config : config addition",
"config : config binding",
"config : config set",
"config : config annotate",
"config : config route",
"creation : CREATE STRING",
"creation : CREATE DEFAULT",
"addition : ADD template PROTO PORT NUMBER action",
"binding : BIND ipaddr template",
"binding : CLONE STRING template",
"set : SET template DEFAULT PROTO ACTION action",
"set : SET template PERSONALITY personality",
"set : SET template UPTIME NUMBER",
"set : SET template DROPRATE IN rate",
"set : SET template UID NUMBER",
"set : SET template UID NUMBER GID NUMBER",
"annotate : ANNOTATE personality finscan",
"annotate : ANNOTATE personality fragment",
"route : ROUTE ENTRY ipaddr",
"route : ROUTE ipaddr ADD NET ipnet ipaddr latency packetloss",
"route : ROUTE ipaddr LINK ipnet",
"finscan : FINSCAN",
"finscan : NO FINSCAN",
"fragment : FRAGMENT DROP",
"fragment : FRAGMENT OLD",
"fragment : FRAGMENT NEW",
"ipaddr : NUMBER DOT NUMBER DOT NUMBER DOT NUMBER",
"ipnet : ipaddr SLASH NUMBER",
"ipaddrplusport : ipaddr COLON NUMBER",
"action : STRING",
"action : CMDSTRING",
"action : PROXY ipaddrplusport",
"action : PROXY STRING COLON NUMBER",
"action : PROXY STRING COLON STRING",
"action : BLOCK",
"action : RESET",
"action : OPEN",
"template : STRING",
"template : DEFAULT",
"template : ipaddr",
"personality : CMDSTRING",
"personality : RANDOM",
"rate : NUMBER DOT NUMBER",
"rate : NUMBER",
"latency :",
"latency : LATENCY NUMBER MS",
"packetloss :",
"packetloss : LOSS rate",
};
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH 10000
#endif
#endif
#define YYINITSTACKSIZE 200
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short *yyss;
short *yysslim;
YYSTYPE *yyvs;
int yystacksize;
#line 416 "parse.y"

int
yyerror(char *fmt, ...)
{
	va_list ap;
	errors = 1;

	va_start(ap, fmt);
	fprintf(stderr, "%s:%d: ", filename, lineno);
	vfprintf(stderr, fmt, ap);
	fprintf(stderr, "\n");
	va_end(ap);
	return (0);
}

int
parse_configuration(FILE *input, char *name)
{
	extern FILE *yyin;

	lineno = 1;
	filename = name;
	yyin = input;
	yyparse();
	return (errors ? -1 : 0);
}
#line 365 "y.tab.c"
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
#if defined(__cplusplus) || __STDC__
static int yygrowstack(void)
#else
static int yygrowstack()
#endif
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;
    i = yyssp - yyss;
    newss = yyss ? (short *)realloc(yyss, newsize * sizeof *newss) :
      (short *)malloc(newsize * sizeof *newss);
    if (newss == NULL)
        goto bail;
    yyss = newss;
    yyssp = newss + i;
    newvs = yyvs ? (YYSTYPE *)realloc(yyvs, newsize * sizeof *newvs) :
      (YYSTYPE *)malloc(newsize * sizeof *newvs);
    if (newvs == NULL)
        goto bail;
    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
bail:
    if (yyss)
            free(yyss);
    if (yyvs)
            free(yyvs);
    yyss = yyssp = NULL;
    yyvs = yyvsp = NULL;
    yystacksize = 0;
    return -1;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
#if defined(__cplusplus) || __STDC__
yyparse(void)
#else
yyparse()
#endif
{
    int yym, yyn, yystate;
#if YYDEBUG
#if defined(__cplusplus) || __STDC__
    const char *yys;
#else /* !(defined(__cplusplus) || __STDC__) */
    char *yys;
#endif /* !(defined(__cplusplus) || __STDC__) */

    if ((yys = getenv("YYDEBUG")))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif /* YYDEBUG */

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#if defined(lint) || defined(__GNUC__)
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#if defined(lint) || defined(__GNUC__)
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 8:
#line 116 "parse.y"
{
		if (template_create(yyvsp[0].string) == -1)
			yyerror("Template \"%s\" exists already", yyvsp[0].string);
		free(yyvsp[0].string);
	}
break;
case 9:
#line 122 "parse.y"
{
		if (template_create("default") == -1)
			yyerror("Template \"default\" exists already");
	}
break;
case 10:
#line 129 "parse.y"
{
		if (yyvsp[-4].tmpl != NULL && template_add(yyvsp[-4].tmpl, yyvsp[-3].number, yyvsp[-1].number, &yyvsp[0].action) == -1)
			yyerror("Can not add port %d to template \"%s\"",
			    yyvsp[-1].number, yyvsp[-4].tmpl != NULL ? yyvsp[-4].tmpl->name : "<unknown>");
		if (yyvsp[0].action.action)
			free(yyvsp[0].action.action);
	}
break;
case 11:
#line 138 "parse.y"
{
		if (yyvsp[0].tmpl == NULL || template_clone(addr_ntoa(&yyvsp[-1].addr), yyvsp[0].tmpl) == -1)
			yyerror("Binding to %s failed", addr_ntoa(&yyvsp[-1].addr));
	}
break;
case 12:
#line 143 "parse.y"
{
		if (yyvsp[0].tmpl == NULL || template_clone(yyvsp[-1].string, yyvsp[0].tmpl) == -1)
			yyerror("Cloning to %s failed", yyvsp[-1].string);
		free(yyvsp[-1].string);
	}
break;
case 13:
#line 150 "parse.y"
{
		struct action *action;

		if (yyvsp[-4].tmpl == NULL) {
			yyerror("No template");
			break;
		}
		
		if ((action = honeyd_protocol(yyvsp[-4].tmpl, yyvsp[-2].number)) == NULL) {
			yyerror("Bad protocol");
			break;
		}

		port_action_clone(action, &yyvsp[0].action);
		if (yyvsp[0].action.action != NULL)
			free(yyvsp[0].action.action);
	}
break;
case 14:
#line 168 "parse.y"
{
		if (yyvsp[-2].tmpl == NULL || yyvsp[0].pers == NULL)
			break;
		yyvsp[-2].tmpl->person = yyvsp[0].pers;
	}
break;
case 15:
#line 174 "parse.y"
{
		if (yyvsp[-2].tmpl == NULL || yyvsp[0].number == 0)
			break;
		yyvsp[-2].tmpl->timestamp = yyvsp[0].number * 2;
	}
break;
case 16:
#line 180 "parse.y"
{
		if (yyvsp[-3].tmpl == NULL)
			break;
		if (yyvsp[0].floatp > 100) {
			yyerror("Droprate too high: %f", yyvsp[0].floatp);
			break;
		}

		yyvsp[-3].tmpl->drop_inrate = yyvsp[0].floatp * 100;
	}
break;
case 17:
#line 191 "parse.y"
{
		if (yyvsp[-2].tmpl == NULL)
			break;
		if (!yyvsp[0].number) {
			yyerror("Bad uid %d", yyvsp[0].number);
			break;
		}
		yyvsp[-2].tmpl->uid = yyvsp[0].number;
	}
break;
case 18:
#line 201 "parse.y"
{
		if (yyvsp[-4].tmpl == NULL)
			break;
		if (!yyvsp[-2].number || !yyvsp[0].number) {
			yyerror("Bad uid %d, gid %d", yyvsp[-2].number, yyvsp[0].number);
			break;
		}
		yyvsp[-4].tmpl->uid = yyvsp[-2].number;
		yyvsp[-4].tmpl->gid = yyvsp[0].number;
	}
break;
case 19:
#line 213 "parse.y"
{
		if (yyvsp[-1].pers == NULL)
			break;
		yyvsp[-1].pers->disallow_finscan = !yyvsp[0].number;
	}
break;
case 20:
#line 219 "parse.y"
{
		if (yyvsp[-1].pers == NULL)
			break;
		yyvsp[-1].pers->fragp = yyvsp[0].fragp;
	}
break;
case 21:
#line 226 "parse.y"
{
		if (router_start(&yyvsp[0].addr) == -1)
			yyerror("Defining entry point failed");
	}
break;
case 22:
#line 231 "parse.y"
{
		struct router *r;

		if ((r = router_find(&yyvsp[-6].addr)) == NULL) {
			yyerror("Unknown router %s", addr_ntoa(&yyvsp[-6].addr));
			break;
		}
		if (router_find(&yyvsp[-2].addr) == NULL)
			router_new(&yyvsp[-2].addr);
		if (router_add_net(r, &yyvsp[-3].addr, &yyvsp[-2].addr, yyvsp[-1].number, yyvsp[0].number) == -1)
			yyerror("Could not add route to %s", addr_ntoa(&yyvsp[-3].addr));
	}
break;
case 23:
#line 244 "parse.y"
{
		struct router *r;

		if ((r = router_find(&yyvsp[-2].addr)) == NULL) {
			yyerror("Unknown router %s", addr_ntoa(&yyvsp[-2].addr));
			break;
		}
		if (router_add_link(r, &yyvsp[0].addr) == -1)
			yyerror("Could not add link %s", addr_ntoa(&yyvsp[0].addr));
	}
break;
case 24:
#line 255 "parse.y"
{ yyval.number = 1; }
break;
case 25:
#line 256 "parse.y"
{ yyval.number = 0; }
break;
case 26:
#line 258 "parse.y"
{ yyval.fragp = FRAG_DROP; }
break;
case 27:
#line 259 "parse.y"
{ yyval.fragp = FRAG_OLD; }
break;
case 28:
#line 260 "parse.y"
{ yyval.fragp = FRAG_NEW; }
break;
case 29:
#line 263 "parse.y"
{
		char src[20];
		snprintf(src, sizeof(src), "%d.%d.%d.%d",
		    yyvsp[-6].number, yyvsp[-4].number, yyvsp[-2].number, yyvsp[0].number);
		if (addr_pton(src, &yyval.addr) < 0)
			yyerror("Illegal IP address %s", src);
	}
break;
case 30:
#line 272 "parse.y"
{
		char src[25];
		snprintf(src, sizeof(src), "%s/%d",
		    addr_ntoa(&yyvsp[-2].addr), yyvsp[0].number);
		if (addr_pton(src, &yyval.addr) < 0)
			yyerror("Illegal IP network %s", src);
	}
break;
case 31:
#line 281 "parse.y"
{
		yyval.ai = cmd_proxy_getinfo(addr_ntoa(&yyvsp[-2].addr), yyvsp[0].number);
		if (yyval.ai == NULL)
			yyerror("Illegal IP address port pair");
	}
break;
case 32:
#line 288 "parse.y"
{
		
		yyval.action.action = yyvsp[0].string;
		yyval.action.status = PORT_OPEN;
	}
break;
case 33:
#line 294 "parse.y"
{
		yyvsp[0].string[strlen(yyvsp[0].string) - 1] = '\0';
		if ((yyval.action.action = strdup(yyvsp[0].string + 1)) == NULL)
			yyerror("Out of memory");
		yyval.action.status = PORT_OPEN;
		free(yyvsp[0].string);
	}
break;
case 34:
#line 302 "parse.y"
{
		yyval.action.status = PORT_PROXY;
		yyval.action.action = NULL;
		yyval.action.aitop = yyvsp[0].ai;
	}
break;
case 35:
#line 308 "parse.y"
{
		yyval.action.status = PORT_PROXY;
		yyval.action.action = NULL;
		yyval.action.aitop = NULL;
		if (yyvsp[-2].string[0] != '$') {
			yyval.action.aitop = cmd_proxy_getinfo(yyvsp[-2].string, yyvsp[0].number);
			if (yyval.action.aitop == NULL)
				yyerror("Illegal host name in proxy");
		} else {
			char proxy[1024];

			snprintf(proxy, sizeof(proxy), "%s:%d", yyvsp[-2].string, yyvsp[0].number);
			yyval.action.action = strdup(proxy);
			if (yyval.action.action == NULL)
				yyerror("Out of memory");
		}
		free(yyvsp[-2].string);
	}
break;
case 36:
#line 327 "parse.y"
{
		char proxy[1024];
		yyval.action.status = PORT_PROXY;
		yyval.action.action = NULL;
		yyval.action.aitop = NULL;

		snprintf(proxy, sizeof(proxy), "%s:%s", yyvsp[-2].string, yyvsp[0].string);
		yyval.action.action = strdup(proxy);
		if (yyval.action.action == NULL)
				yyerror("Out of memory");
		free(yyvsp[-2].string);
		free(yyvsp[0].string);
	}
break;
case 37:
#line 341 "parse.y"
{
		yyval.action.status = PORT_BLOCK;
		yyval.action.action = NULL;
	}
break;
case 38:
#line 346 "parse.y"
{
		yyval.action.status = PORT_RESET;
		yyval.action.action = NULL;
	}
break;
case 39:
#line 351 "parse.y"
{
		yyval.action.status = PORT_OPEN;
		yyval.action.action = NULL;
	}
break;
case 40:
#line 358 "parse.y"
{
		yyval.tmpl = template_find(yyvsp[0].string);
		if (yyval.tmpl == NULL)
			yyerror("Unknown template \"%s\"", yyvsp[0].string);
		free(yyvsp[0].string);
	}
break;
case 41:
#line 365 "parse.y"
{
		yyval.tmpl = template_find("default");
		if (yyval.tmpl == NULL)
			yyerror("Unknown template \"%s\"", "default");
	}
break;
case 42:
#line 371 "parse.y"
{
		yyval.tmpl = template_find(addr_ntoa(&yyvsp[0].addr));
		if (yyval.tmpl == NULL)
			yyerror("Unknown template \"%s\"", yyvsp[0].addr);
	}
break;
case 43:
#line 378 "parse.y"
{
		yyvsp[0].string[strlen(yyvsp[0].string) - 1] = '\0';
		yyval.pers = personality_find(yyvsp[0].string+1);
		if (yyval.pers == NULL)
			yyerror("Unknown personality \"%s\"", yyvsp[0].string+1);
		free(yyvsp[0].string);
	}
break;
case 44:
#line 386 "parse.y"
{
		yyval.pers = personality_random();
		if (yyval.pers == NULL)
			yyerror("Random personality failed");
	}
break;
case 45:
#line 393 "parse.y"
{
		char asc[40];

		snprintf(asc, sizeof(asc), "%d.%d", yyvsp[-2].number, yyvsp[0].number);
		yyval.floatp = atof(asc);
	}
break;
case 46:
#line 400 "parse.y"
{
		yyval.floatp = yyvsp[0].number;
	}
break;
case 47:
#line 404 "parse.y"
{ yyval.number = 0; }
break;
case 48:
#line 406 "parse.y"
{
		yyval.number = yyvsp[-1].number;
	}
break;
case 49:
#line 410 "parse.y"
{ yyval.number = 0; }
break;
case 50:
#line 412 "parse.y"
{
		yyval.number = yyvsp[0].floatp * 100;
	}
break;
#line 933 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
